//------------------------------------------------------------------------------
// ServerSidePanels/Common/msxb.js
//
// Cross-browser functionality
//
// <copyright from='2006' to='2007' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var msxb =
{
	listenerHash: [],

	addEventListener: function(_elem, _evtName, _fn, _useCapture)
	{
		if (typeof _elem.addEventListener != 'undefined')
		{
			if (_evtName == 'mouseenter')
				{ _elem.addEventListener('mouseover', msxb.MouseEnter(_fn), _useCapture); }
			else if (_evtName == 'mouseleave')
				{ _elem.addEventListener('mouseout', msxb.MouseEnter(_fn), _useCapture); }
			else
				{ _elem.addEventListener(_evtName, _fn, _useCapture); }
		}
		else if (typeof _elem.attachEvent != 'undefined')
		{
			var key = '{FNKEY::obj_' + _elem.uniqueID + '::evt_' + _evtName + '::fn_' + _fn + '}';            
			var f = msxb.listenerHash[key];            
			if (typeof f != 'undefined')
				{ return; }

			var f = function(_evt)
			{
				_evt = window.event || _evt;
				_fn.call(_elem, _evt);
			};

			msxb.listenerHash[key] = f;            
			_elem.attachEvent('on' + _evtName, f);
			window.attachEvent('onunload', function()
			{
				_elem.detachEvent('on' + _evtName, f);
			});

			key = null;
			//f = null;				/* Can't null out f or IE won't be able to detach at unload time, thereby _causing_ a memory leak */
		}
		else
			{ _elem['on' + _evtName] = _fn; }
	},

	removeEventListener: function(_elem, _evtName, _fn, _useCapture)
	{
		if (typeof _elem.removeEventListener != 'undefined')
			{ _elem.removeEventListener(_evtName, _fn, _useCapture); }
		else if (typeof _elem.detachEvent != 'undefined')
		{
			var key = '{FNKEY::obj_' + _elem.uniqueID + '::evt_' + _evtName + '::fn_' + _fn + '}';            
			var f = msxb.listenerHash [key];
			if (typeof f != 'undefined')
			{
				_elem.detachEvent('on' + _evtName, f);
				delete msxb.listenerHash[key];
			}

			key = f = null;			
		}
	},

	MouseEnter: function(_pFn)
	{
		return function(_evt)
		{
			var relTarget = _evt.relatedTarget;                
			if (this == relTarget || msxb.isAChildOf(this, relTarget))
				{ return; }

			_pFn.call(this, _evt);
		}
	},

	preventDefaultAction: function(_evt)
	{
		if (_evt)
		{
			if (typeof _evt.preventDefault != 'undefined')
				{ _evt.preventDefault(); }                        // W3C
			else
				{ _evt.returnValue = false; }                     // IE
		}

		// safey for handling DOM Level 0 (need to call this function as: return preventDefaultAction(evt) for this to have any effect)
		return false;
	},

	stopEventPropagation: function(_evt)
	{
		if (_evt)
		{
			if (typeof _evt.stopPropagation != 'undefined')
				{ _evt.stopPropagation(); }											// W3C
			else if (_evt.cancelBubble != 'undefined')
				{ _evt.cancelBubble = true; }										// IE
		}
	},

	isAChildOf: function(_parent, _child)
	{
		if (_parent == _child) { return false };

		while (_child && _child != _parent)
		{ _child = _child.parentNode; }

		return _child == _parent;
	},

	getElementsByClassName: function(_className, _startElem, _filterTag)
	{
		_startElem = _startElem || document;
		_filterTag = _filterTag || '*';

		var arr = [];
		var tags;

		if (typeof window.opera == 'undefined' && document.all && _filterTag == '*')
			{ tags = _startElem.all; }
		else
			{ tags = _startElem.getElementsByTagName(_filterTag); }

		var i, len = tags.length;            
		for (i = 0; i < len; i++)
		{
			var elem = tags[i];
			if (_className.test(elem.className))
				{ arr.push(elem); }
		}

		return arr;
	}
}